@import "../../scss/colors";
@import "../../scss/mixin";

$tweakpoints: (
  "small": 320px,
  "inline": 650px,
  "block": 980px
) !default;

$checkbox__size: 1rem;
$switch__size: $checkbox__size;

$checkbox__border__size: 0.125rem;

$checkbox__border__color: $color__primary;

$checkbox__border__color--disabled: $color__back--high;

$checkbox__checkmark__size: $checkbox__size - (2 * $checkbox__border__size);
$checkbox__checkmark__size--indeterminate: 0.125rem;

$checkbox__checkmark__color: $color__primary--low;
$checkbox__checkmark__color--disabled: $color__back--high;

$checkbox__label__color: $color__text;
$checkbox__label__color--disabled: $color__text--low;

.m-checkbox {
  display: flex;
  align-items: center;
  padding: 0.5rem;
  @include respond-to("small") {
    // top: -2rem;
    width: 9rem;
    // position: relative;
    font-size: 0.7rem;
  }

  &__label {
    width: 100%;
    padding: 0.5rem 0.5rem;
    color: $checkbox__label__color;
    cursor: pointer;
  }

  &__input {
    position: relative;
    flex-shrink: 0;
    width: $checkbox__size;
    height: $checkbox__size;
    appearance: none;
    -webkit-appearance: none;
    -moz-appearance: none;
    outline: none; // TODO: manage :focus
    background: $color__back;
    cursor: pointer;
    border: $checkbox__border__size solid $checkbox__border__color;

    &::before {
      content: " ";
      position: absolute;
      top: 50%;
      right: 50%;
      bottom: 50%;
      left: 50%;
      transition: all 0.1s;
      background: $checkbox__checkmark__color;
    }

    &:checked,
    &:indeterminate {
      &::before {
        top: $checkbox__border__size;
        right: $checkbox__border__size;
        bottom: $checkbox__border__size;
        left: $checkbox__border__size;
      }
    }

    &:indeterminate {
      &::before {
        top: ($checkbox__checkmark__size / 2) -
          ($checkbox__checkmark__size--indeterminate / 2);
        bottom: ($checkbox__checkmark__size / 2) -
          ($checkbox__checkmark__size--indeterminate / 2);
      }
    }

    &:disabled {
      border-color: $checkbox__border__color--disabled;
      cursor: default;

      &::before {
        background-color: $checkbox__checkmark__color--disabled;
      }

      + .m-checkbox__label {
        color: $checkbox__label__color--disabled;
        cursor: default;
      }
    }
  }

  &--has-error {
    &__input {
      border-color: $color-one;
      background-color: rgba($color-one, 0.2);

      &::before {
        background-color: $color-one;
      }
    }
  }

  &--switch {
    &__label {
      &::after {
        content: "off";
        margin-left: 0.25rem;
      }
    }

    &__input {
      width: (2 * $switch__size) - (2 * $checkbox__border__size);
      height: $switch__size;
      border: $checkbox__border__size solid $checkbox__border__color--disabled;
      border-radius: $checkbox__checkmark__size;

      &::before {
        top: $checkbox__border__size;
        right: $switch__size - $checkbox__border__size;
        bottom: $checkbox__border__size;
        left: $checkbox__border__size;
        border-radius: 50%;
        background: $checkbox__checkmark__color--disabled;
      }

      &:checked {
        border-color: $checkbox__border__color;

        + .m-checkbox--switch__label {
          &::after {
            content: "on";
          }
        }

        &::before {
          right: $checkbox__border__size;
          left: $switch__size - $checkbox__border__size;
          background: $checkbox__border__color;
        }
      }
    }
  }
}
